-- The apply function are recreated with the keyword
-- EXTERNAL ACTION instead of NO EXTERNAL ACTION.
-- The advantage is that the apply functions are not
-- executed more than one time per record if they are
-- used in common table expressions.

DROP FUNCTION IDMMX.DM_applyClasModel;
DROP FUNCTION IDMMX.DM_applyClusModel;
DROP FUNCTION IDMMX.DM_applyRegModel;

CREATE FUNCTION IDMMX.DM_applyClasModel(
   IDMMX.DM_ClasModel AS LOCATOR,
   IDMMX.DM_ApplicationData AS LOCATOR)
 RETURNS IDMMX.DM_ClasResult
 NOT FENCED
 EXTERNAL NAME 'idmclf!udf_applyClassifMdl'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 SCRATCHPAD
 FINAL CALL
 ALLOW PARALLEL
 DBINFO;

CREATE FUNCTION IDMMX.DM_applyClusModel(
   IDMMX.DM_ClusteringModel AS LOCATOR,
   IDMMX.DM_ApplicationData AS LOCATOR)
 RETURNS IDMMX.DM_ClusResult
 NOT FENCED
 EXTERNAL NAME 'idmclu!udf_applyClusterMdl'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 SCRATCHPAD
 FINAL CALL
 ALLOW PARALLEL
 DBINFO;

CREATE FUNCTION IDMMX.DM_applyRegModel(
   IDMMX.DM_RegressionModel AS LOCATOR,
   IDMMX.DM_ApplicationData AS LOCATOR)
 RETURNS IDMMX.DM_RegResult
 NOT FENCED
 EXTERNAL NAME 'idmreg!udf_applyRegressMdl'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 SCRATCHPAD
 FINAL CALL
 ALLOW PARALLEL
 DBINFO;
