--  Licensed Materials - Property of IBM
--
--  5724-A60
--  (C) Copyright IBM Corporation 2001
--
--  ALL rights reserved.
--  US Government Users Restricted Rights -
--  Use, duplication or disclosure restricted by GSA ADP
--  Schedule Contract with IBM Corporation.
--















--DROP TYPE IDMMX .DM_ClasResult;
--DROP TYPE IDMMX .DM_ClasModel;
CREATE DISTINCT TYPE IDMMX .DM_ClasResult AS VARCHAR(256) WITH COMPARISONS;
CREATE DISTINCT TYPE IDMMX .DM_ClasModel AS BLOB(10M  );


--
--DROP FUNCTION IDMMX .DM_applyClasModel;
--DROP FUNCTION IDMMX .DM_impClasFile;
--DROP FUNCTION IDMMX .DM_impClasFileE;
--DROP FUNCTION IDMMX .DM_impClasModel;
--DROP FUNCTION IDMMX .DM_getClasMdlName;
--DROP FUNCTION IDMMX .DM_getPredClass;
--DROP FUNCTION IDMMX .DM_getConfidence;
--
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_applyClassifMdl':
-- DM_ClasModel, DM_ApplicationData)        -> used in fenced mode
-- DM_ClasModel AS LOCATOR, DM_ApplicationData AS LOCATOR ) -> used in unfenced mode
-- FENCED                                      -> used without LOCATOR
-- NOT FENCED                                  -> used with LOCATOR
-- EXTERNAL NAME 'idmclf!udf_applyClassifMdlF' -> used without LOCATOR in fenced mode
-- EXTERNAL NAME 'idmclf!udf_applyClassifMdl'  -> used with LOCATOR in unfenced mode
-- EXTERNAL NAME 'idmtest!udf_applyClassifMdlF'-> used without LOCATOR, counts number of calls
-- EXTERNAL NAME 'idmtest!udf_applyClassifMdl' -> used with LOCATOR, counts number of calls
--


CREATE FUNCTION IDMMX .DM_applyClasModel(
   IDMMX .DM_ClasModel  ,
   IDMMX .DM_ApplicationData  )
 RETURNS IDMMX .DM_ClasResult
 FENCED 
 EXTERNAL NAME 'idmclf!udf_applyClassifMdlF' 
-- EXTERNAL NAME 'idmtest!udf_applyClassifMdlF'
-- EXTERNAL NAME 'idmtest!udf_applyClassifMdl'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 SCRATCHPAD
 FINAL CALL
 ALLOW PARALLEL
 DBINFO;


--
-- Doku of changable parameters for 'CREATE FUNCTION DM_impClasFile':
-- RETURNS DM_ClasModel                       -> used in fended or unfenced mode
-- RETURNS DM_ClasModel AS LOCATOR            -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmclf!udf_impClassifFileF' -> used without LOCATOR
-- EXTERNAL NAME 'idmclf!udf_impClassifFile'  -> used with LOCATOR
--

CREATE FUNCTION IDMMX .DM_impClasFile(
   VARCHAR(256) )
 RETURNS IDMMX .DM_ClasModel  
 FENCED 
 EXTERNAL NAME 'idmclf!udf_impClassifFileF' 
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 DBINFO;
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_impClasFileE':
-- RETURNS DM_ClasModel                 -> used in fended or unfenced mode
-- RETURNS DM_ClasModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmclf!udf_impClassifFileEF' -> used without LOCATOR
-- EXTERNAL NAME 'idmclf!udf_impClassifFileE'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_impClasFileE(
   VARCHAR(256),
   VARCHAR(20))
 RETURNS IDMMX .DM_ClasModel  
 FENCED 
 EXTERNAL NAME 'idmclf!udf_impClassifFileEF' 
 NULL CALL
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 DBINFO;
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_impClasModel':
-- RETURNS DM_ClasModel                 -> used in fenced or unfenced mode
-- RETURNS DM_ClasModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmclf!udf_impClassifModelF' -> used without LOCATOR
-- EXTERNAL NAME 'idmclf!udf_impClassifModel'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_impClasModel(
   CLOB(5M )   )
 RETURNS IDMMX .DM_ClasModel  
 FENCED 
 EXTERNAL NAME 'idmclf!udf_impClassifModelF' 
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION
 DBINFO;
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_getClasMdlName':
-- RETURNS DM_ClasModel                 -> used in fended or unfenced mode
-- RETURNS DM_ClasModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmclf!udf_getClassifModelNameF' -> used without LOCATOR
-- EXTERNAL NAME 'idmclf!udf_getClassifModelName'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_getClasMdlName(
   IDMMX .DM_ClasModel  
   )
 RETURNS VARCHAR(256)
 FENCED 
 EXTERNAL NAME 'idmclf!udf_getClassifModelNameF' 
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 DBINFO;
--
--

CREATE FUNCTION IDMMX .DM_getPredClass(IDMMX .DM_ClasResult)
 RETURNS VARCHAR(100)
 NOT FENCED
 EXTERNAL NAME 'idmclf!udf_getPredClass'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;
--

CREATE FUNCTION IDMMX .DM_getConfidence(IDMMX .DM_ClasResult)
 RETURNS DOUBLE
 NOT FENCED
 EXTERNAL NAME 'idmclf!udf_getClassifConf'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;

