--  Licensed Materials - Property of IBM
--
--  5724-A60
--  (C) Copyright IBM Corporation 2001
--
--  ALL rights reserved.
--  US Government Users Restricted Rights -
--  Use, duplication or disclosure restricted by GSA ADP
--  Schedule Contract with IBM Corporation.
--
















--DROP TYPE IDMMX .DM_ClusResult;
--DROP TYPE IDMMX .DM_ClusteringModel;
CREATE DISTINCT TYPE IDMMX .DM_ClusResult AS VARCHAR(256) WITH COMPARISONS;

CREATE DISTINCT TYPE IDMMX .DM_ClusteringModel AS BLOB(100M  );

--
--DROP FUNCTION IDMMX .DM_applyClusModel;
--DROP FUNCTION IDMMX .DM_impClusFile;
--DROP FUNCTION IDMMX .DM_impClusFileE;
--DROP FUNCTION IDMMX .DM_impClusModel;
--DROP FUNCTION IDMMX .DM_getClusMdlName;
--DROP FUNCTION IDMMX .DM_getClusterId;
--DROP FUNCTION IDMMX .DM_getClusScore;
--DROP FUNCTION IDMMX .DM_getClusterId2;
--DROP FUNCTION IDMMX .DM_getClusScore2;
--DROP FUNCTION IDMMX .DM_getClusConf;
--

-- Doku of changable parameters for 'CREATE FUNCTION DM_applyClusterMdl':
-- DM_ClusteringModel, DM_ApplicationData)     -> used in fenced mode
-- DM_ClusteringModel AS LOCATOR, DM_ApplicationData AS LOCATOR ) -> used in unfenced mode
-- FENCED                                      ->used without LOCATOR
-- NOT FENCED                                  -> used with LOCATOR
-- EXTERNAL NAME 'idmclu!udf_applyClusterMdlF' -> used without LOCATOR in fenced mode
-- EXTERNAL NAME 'idmclu!udf_applyClusterMdl'  -> used with LOCATOR in unfenced mode
-- EXTERNAL NAME 'idmtest!udf_applyClusterMdlF'-> used without LOCATOR, counts number of calls
-- EXTERNAL NAME 'idmtest!udf_applyClusterMdl' -> used with LOCATOR, counts number of calls
--
CREATE FUNCTION IDMMX .DM_applyClusModel(
   IDMMX .DM_ClusteringModel AS LOCATOR ,
   IDMMX .DM_ApplicationData AS LOCATOR )
 RETURNS IDMMX .DM_ClusResult
 NOT FENCED 
 EXTERNAL NAME 'idmclu!udf_applyClusterMdl' 
-- EXTERNAL NAME 'idmtest!udf_applyClusterMdlF'
-- EXTERNAL NAME 'idmtest!udf_applyClusterMdl'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 SCRATCHPAD
 FINAL CALL
 ALLOW PARALLEL
 DBINFO;

--
-- Doku of changable parameters for 'CREATE FUNCTION DM_impClusFile':
-- RETURNS DM_ClusteringModel                    -> used in fended or unfenced mode
-- RETURNS DM_ClusteringModel AS LOCATOR         -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmclu!udf_impClusterFileF' -> used without LOCATOR
-- EXTERNAL NAME 'idmclu!udf_impClusterFile'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_impClusFile(
   VARCHAR(256) )
 RETURNS IDMMX .DM_ClusteringModel AS LOCATOR 
 NOT FENCED 
 EXTERNAL NAME 'idmclu!udf_impClusterFile' 
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 DBINFO;
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_impClusFileE':
-- RETURNS DM_ClusteringModel                 -> used in fended or unfenced mode
-- RETURNS DM_ClusteringModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmclu!udf_impClusterFileEF' -> used without LOCATOR
-- EXTERNAL NAME 'idmclu!udf_impClusterFileE'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_impClusFileE(
   VARCHAR(256),
   VARCHAR(20))
 RETURNS IDMMX .DM_ClusteringModel AS LOCATOR 
 NOT FENCED 
 EXTERNAL NAME 'idmclu!udf_impClusterFileE' 
 NULL CALL
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 DBINFO;
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_impClusModel':
-- RETURNS DM_ClusteringModel                 -> used in fended or unfenced mode
-- RETURNS DM_ClusteringModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmclu!udf_impClusterModelF' -> used without LOCATOR
-- EXTERNAL NAME 'idmclu!udf_impClusterModel'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_impClusModel(
   CLOB(50M ) AS LOCATOR  )
 RETURNS IDMMX .DM_ClusteringModel AS LOCATOR 
 NOT FENCED 
 EXTERNAL NAME 'idmclu!udf_impClusterModel' 
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION
 DBINFO;
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_getClusMdlName':
-- RETURNS DM_ClusteringModel                 -> used in fended or unfenced mode
-- RETURNS DM_ClusteringModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmclu!udf_getClusterModelNameF' -> used without LOCATOR
-- EXTERNAL NAME 'idmclu!udf_getClusterModelName'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_getClusMdlName(
   IDMMX .DM_ClusteringModel AS LOCATOR 
   )
 RETURNS VARCHAR(256)
 NOT FENCED 
 EXTERNAL NAME 'idmclu!udf_getClusterModelName' 
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 DBINFO;
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_getClusMdlType':
-- RETURNS DM_ClusteringModel                 -> used in fended or unfenced mode
-- RETURNS DM_ClusteringModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmclu!udf_getClusterModelTypeF' -> used without LOCATOR
-- EXTERNAL NAME 'idmclu!udf_getClusterModelType'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_getClusMdlType(
   IDMMX .DM_ClusteringModel AS LOCATOR 
   )
 RETURNS VARCHAR(256)
 NOT FENCED 
 EXTERNAL NAME 'idmclu!udf_getClusterModelType' 
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 DBINFO;
--

CREATE FUNCTION IDMMX .DM_getClusterID(IDMMX .DM_ClusResult)
 RETURNS INTEGER
 NOT FENCED
 EXTERNAL NAME 'idmclu!udf_getClusterId'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;

CREATE FUNCTION IDMMX .DM_getClusScore(IDMMX .DM_ClusResult)
 RETURNS DOUBLE
 NOT FENCED
 EXTERNAL NAME 'idmclu!udf_getClusterScore'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;

CREATE FUNCTION IDMMX .DM_getClusterID2(IDMMX .DM_ClusResult)
 RETURNS INTEGER
 NOT FENCED
 EXTERNAL NAME 'idmclu!udf_getClusterId2'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;

CREATE FUNCTION IDMMX .DM_getClusScore2(IDMMX .DM_ClusResult)
 RETURNS DOUBLE
 NOT FENCED
 EXTERNAL NAME 'idmclu!udf_getClusterScore2'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;

CREATE FUNCTION IDMMX .DM_getClusConf(IDMMX .DM_ClusResult)
 RETURNS DOUBLE
 NOT FENCED
 EXTERNAL NAME 'idmclu!udf_getClusterConf'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;
