--  Licensed Materials - Property of IBM
--
--  5724-A60
--  (C) Copyright IBM Corporation 2001
--
--  ALL rights reserved.
--  US Government Users Restricted Rights -
--  Use, duplication or disclosure restricted by GSA ADP
--  Schedule Contract with IBM Corporation.
--















--DROP TYPE IDMMX .DM_RegResult;
--DROP TYPE IDMMX .DM_RegressionModel;
CREATE DISTINCT TYPE IDMMX .DM_RegResult AS VARCHAR(256) WITH COMPARISONS;
CREATE DISTINCT TYPE IDMMX .DM_RegressionModel AS BLOB(10M  );
--
--DROP FUNCTION IDMMX .DM_applyRegModel;
--DROP FUNCTION IDMMX .DM_impRegFile;
--DROP FUNCTION IDMMX .DM_impRegFileE;
--DROP FUNCTION IDMMX .DM_impRegModel;
--DROP FUNCTION IDMMX .DM_getRegMdlName;
--DROP FUNCTION IDMMX .DM_getPredValue;
--DROP FUNCTION IDMMX .DM_getRBFRegionID;
--DROP FUNCTION IDMMX .DM_getLowerQuant;
--DROP FUNCTION IDMMX .DM_getUpperQuant;
--

-- Doku of changable parameters for 'CREATE FUNCTION DM_applyRegressMdl':
-- DM_RegressionModel, DM_ApplicationData)     -> used in fenced mode
-- DM_RegressionModel AS LOCATOR, DM_ApplicationData AS LOCATOR ) -> used in unfenced mode
-- FENCED                                      ->used without LOCATOR
-- NOT FENCED                                  -> used with LOCATOR
-- EXTERNAL NAME 'idmreg!udf_applyRegressMdlF' -> used without LOCATOR in fenced mode
-- EXTERNAL NAME 'idmreg!udf_applyRegressMdl'  -> used with LOCATOR in unfenced mode
-- EXTERNAL NAME 'idmtest!udf_applyRegressMdlF'-> used without LOCATOR, counts number of calls
-- EXTERNAL NAME 'idmtest!udf_applyRegressMdl' -> used with LOCATOR, counts number of calls
--
CREATE FUNCTION IDMMX .DM_applyRegModel(
   IDMMX .DM_RegressionModel  ,
   IDMMX .DM_ApplicationData  )
 RETURNS IDMMX .DM_RegResult
 FENCED 
 EXTERNAL NAME 'idmreg!udf_applyRegressMdlF' 
-- EXTERNAL NAME 'idmtest!udf_applyRegressMdlF'
-- EXTERNAL NAME 'idmtest!udf_applyRegressMdl'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 SCRATCHPAD
 FINAL CALL
 ALLOW PARALLEL
 DBINFO;

--
-- Doku of changable parameters for 'CREATE FUNCTION DM_impRegFile':
-- RETURNS DM_RegressionModel                 -> used in fended or unfenced mode
-- RETURNS DM_RegressionModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmreg!udf_impRegressFileF' -> used without LOCATOR
-- EXTERNAL NAME 'idmreg!udf_impRegressFile'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_impRegFile(
   VARCHAR(256) )
 RETURNS IDMMX .DM_RegressionModel  
 FENCED 
 EXTERNAL NAME 'idmreg!udf_impRegressFileF' 
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 DBINFO;
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_impRegFileE':
-- RETURNS DM_RegressionModel                 -> used in fended or unfenced mode
-- RETURNS DM_RegressionModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmreg!udf_impRegressFileEF' -> used without LOCATOR
-- EXTERNAL NAME 'idmreg!udf_impRegressFileE'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_impRegFileE(
   VARCHAR(256),
   VARCHAR(20))
 RETURNS IDMMX .DM_RegressionModel  
 FENCED 
 EXTERNAL NAME 'idmreg!udf_impRegressFileEF' 
 NULL CALL
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 DBINFO;
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_impRegModel':
-- RETURNS DM_RegressionModel                 -> used in fended or unfenced mode
-- RETURNS DM_RegressionModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmreg!udf_impRegressModelF' -> used without LOCATOR
-- EXTERNAL NAME 'idmreg!udf_impRegressModel'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_impRegModel(
   CLOB(5M )   )
 RETURNS IDMMX .DM_RegressionModel  
 FENCED 
 EXTERNAL NAME 'idmreg!udf_impRegressModelF' 
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION
 DBINFO;
--
-- Doku of changable parameters for 'CREATE FUNCTION DM_getRegMdlName':
-- RETURNS DM_RegressionModel                 -> used in fended or unfenced mode
-- RETURNS DM_RegressionModel AS LOCATOR      -> used in unfenced mode
-- FENCED                                     -> used without LOCATOR
-- NOT FENCED                                 -> used with out without LOCATOR
-- EXTERNAL NAME 'idmreg!udf_getRegressModelNameF' -> used without LOCATOR
-- EXTERNAL NAME 'idmreg!udf_getRegressModelName'  -> used with LOCATOR
--
CREATE FUNCTION IDMMX .DM_getRegMdlName(
   IDMMX .DM_RegressionModel  
   )
 RETURNS VARCHAR(256)
 FENCED 
 EXTERNAL NAME 'idmreg!udf_getRegressModelNameF' 
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 EXTERNAL ACTION
 DBINFO;
--
CREATE FUNCTION IDMMX .DM_getPredValue(IDMMX .DM_RegResult)
 RETURNS DOUBLE
 NOT FENCED
 EXTERNAL NAME 'idmreg!udf_getPredValue'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;

CREATE FUNCTION IDMMX .DM_getUpperQuant(IDMMX .DM_RegResult)
 RETURNS DOUBLE
 NOT FENCED
 EXTERNAL NAME 'idmreg!udf_getUpperQuant'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;

CREATE FUNCTION IDMMX .DM_getLowerQuant(IDMMX .DM_RegResult)
 RETURNS DOUBLE
 NOT FENCED
 EXTERNAL NAME 'idmreg!udf_getLowerQuant'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;

CREATE FUNCTION IDMMX .DM_getRBFRegionID(IDMMX .DM_RegResult)
 RETURNS INTEGER
 NOT FENCED
 EXTERNAL NAME 'idmreg!udf_getRegionId'
 NOT VARIANT
 NO SQL
 PARAMETER STYLE DB2SQL
 LANGUAGE C
 NO EXTERNAL ACTION;

